(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/common'), require('@angular/router'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('angular-l10n', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/common', '@angular/router', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['angular-l10n'] = {}, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.common, global.ng.router, global.ng.forms));
}(this, (function (exports, i0, rxjs, operators, common, router, forms) { 'use strict';

    /**
     * L10n configuration token.
     */
    var L10N_CONFIG = new i0.InjectionToken('L10N_CONFIG');
    /**
     * L10n locale token.
     */
    var L10N_LOCALE = new i0.InjectionToken('L10N_LOCALE');

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    function l10nError(type, value) {
        return "angular-l10n (" + type.name + "): " + value;
    }

    function validateLanguage(language) {
        var regExp = new RegExp(/^([a-z]{2,3})(\-[A-Z][a-z]{3})?(\-[A-Z]{2})?(-u.+)?$/);
        return regExp.test(language);
    }
    function formatLanguage(language, format) {
        if (language == null || language === '')
            return '';
        if (!validateLanguage(language))
            throw l10nError(formatLanguage, 'Invalid language');
        var _a = __read(language.match(/^([a-z]{2,3})(\-[A-Z][a-z]{3})?(\-[A-Z]{2})?/) || [], 4), _b = _a[1], LANGUAGE = _b === void 0 ? '' : _b, _c = _a[2], SCRIPT = _c === void 0 ? '' : _c, _d = _a[3], REGION = _d === void 0 ? '' : _d;
        switch (format) {
            case 'language':
                return LANGUAGE;
            case 'language-script':
                return LANGUAGE + SCRIPT;
            case 'language-region':
                return LANGUAGE + REGION;
            case 'language-script-region':
                return LANGUAGE + SCRIPT + REGION;
        }
    }
    function parseLanguage(language) {
        var groups = language.match(/^([a-z]{2,3})(\-([A-Z][a-z]{3}))?(\-([A-Z]{2}))?(-u.+)?$/);
        if (groups == null)
            throw l10nError(parseLanguage, 'Invalid language');
        return {
            language: groups[1],
            script: groups[3],
            region: groups[5],
            extension: groups[6]
        };
    }
    function getBrowserLanguage(format) {
        var browserLanguage = null;
        if (typeof navigator !== 'undefined' && navigator.language) {
            switch (format) {
                case 'language-region':
                case 'language-script-region':
                    browserLanguage = navigator.language;
                    break;
                default:
                    browserLanguage = navigator.language.split('-')[0];
            }
        }
        return browserLanguage;
    }
    function getSchema(schema, language, format) {
        var element = schema.find(function (item) { return formatLanguage(item.locale.language, format) === language; });
        return element;
    }
    function getValue(key, data, keySeparator) {
        if (data) {
            if (keySeparator) {
                return key.split(keySeparator).reduce(function (acc, cur) { return (acc && acc[cur]) != null ? acc[cur] : null; }, data);
            }
            return data[key] != null ? data[key] : null;
        }
        return null;
    }
    function handleParams(value, params) {
        var replacedValue = value.replace(/{{\s?([^{}\s]*)\s?}}/g, function (substring, parsedKey) {
            var replacer = params[parsedKey];
            return replacer !== undefined ? replacer : substring;
        });
        return replacedValue;
    }
    function mergeDeep(target, source) {
        var output = Object.assign({}, target);
        if (isObject(target) && isObject(source)) {
            Object.keys(source).forEach(function (key) {
                var _a, _b;
                if (isObject(source[key])) {
                    if (!(key in target)) {
                        Object.assign(output, (_a = {}, _a[key] = source[key], _a));
                    }
                    else {
                        output[key] = mergeDeep(target[key], source[key]);
                    }
                }
                else {
                    Object.assign(output, (_b = {}, _b[key] = source[key], _b));
                }
            });
        }
        return output;
    }
    function hasIntl() {
        var isAvailable = typeof Intl === 'object' && !!Intl;
        return isAvailable;
    }
    function hasDateTimeFormat() {
        return hasIntl() && Intl.hasOwnProperty('DateTimeFormat');
    }
    function hasNumberFormat() {
        return hasIntl() && Intl.hasOwnProperty('NumberFormat');
    }
    function hasTimeZone() {
        if (hasIntl() && hasDateTimeFormat()) {
            try {
                new Intl.DateTimeFormat('en-US', { timeZone: 'America/Los_Angeles' }).format(new Date());
            }
            catch (e) {
                return false;
            }
            return true;
        }
        return false;
    }
    function hasRelativeTimeFormat() {
        return hasIntl() && Intl.hasOwnProperty('RelativeTimeFormat');
    }
    function hasCollator() {
        return hasIntl() && Intl.hasOwnProperty('Collator');
    }
    function hasPluralRules() {
        return hasIntl() && Intl.hasOwnProperty('PluralRules');
    }
    function hasListFormat() {
        return hasIntl() && Intl.hasOwnProperty('ListFormat');
    }
    function hasDisplayNames() {
        return hasIntl() && Intl.hasOwnProperty('DisplayNames');
    }
    function toNumber(value) {
        var parsedValue = typeof value === 'string' && !isNaN(+value - parseFloat(value)) ? +value : value;
        return parsedValue;
    }
    function toDate(value) {
        if (isDate(value)) {
            return value;
        }
        if (typeof value === 'number' && !isNaN(value)) {
            return new Date(value);
        }
        if (typeof value === 'string') {
            value = value.trim();
            if (!isNaN(value - parseFloat(value))) {
                return new Date(parseFloat(value));
            }
            if (/^(\d{4}-\d{1,2}-\d{1,2})$/.test(value)) {
                var _a = __read(value.split('-').map(function (val) { return +val; }), 3), y = _a[0], m = _a[1], d = _a[2];
                return new Date(y, m - 1, d);
            }
            var match = value.match(/^(\d{4})-?(\d\d)-?(\d\d)(?:T(\d\d)(?::?(\d\d)(?::?(\d\d)(?:\.(\d+))?)?)?(Z|([+-])(\d\d):?(\d\d))?)?$/);
            if (match) {
                return isoStringToDate(match);
            }
        }
        var date = new Date(value);
        if (!isDate(date)) {
            throw l10nError(toDate, 'Invalid date');
        }
        return date;
    }
    var PARSE_DATE_STYLE = {
        full: { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric' },
        long: { year: 'numeric', month: 'long', day: 'numeric' },
        medium: { year: 'numeric', month: 'short', day: 'numeric' },
        short: { year: '2-digit', month: 'numeric', day: 'numeric' }
    };
    var PARSE_TIME_STYLE = {
        full: { hour: 'numeric', minute: 'numeric', second: 'numeric', timeZoneName: 'long' },
        long: { hour: 'numeric', minute: 'numeric', second: 'numeric', timeZoneName: 'short' },
        medium: { hour: 'numeric', minute: 'numeric', second: 'numeric' },
        short: { hour: 'numeric', minute: 'numeric' }
    };
    function parseDigits(digits) {
        var groups = digits.match(/^(\d+)?\.((\d+)(\-(\d+))?)?$/);
        if (groups == null)
            throw l10nError(parseDigits, 'Invalid digits');
        return {
            minimumIntegerDigits: groups[1] ? parseInt(groups[1]) : undefined,
            minimumFractionDigits: groups[3] ? parseInt(groups[3]) : undefined,
            maximumFractionDigits: groups[5] ? parseInt(groups[5]) : undefined,
        };
    }
    function isObject(item) {
        return typeof item === 'object' && !Array.isArray(item);
    }
    function isDate(value) {
        return value instanceof Date && !isNaN(value.valueOf());
    }
    /**
     * Converts a date in ISO 8601 to a Date.
     */
    function isoStringToDate(match) {
        var date = new Date(0);
        var tzHour = 0;
        var tzMin = 0;
        var dateSetter = match[8] ? date.setUTCFullYear : date.setFullYear;
        var timeSetter = match[8] ? date.setUTCHours : date.setHours;
        if (match[9]) {
            tzHour = Number(match[9] + match[10]);
            tzMin = Number(match[9] + match[11]);
        }
        dateSetter.call(date, Number(match[1]), Number(match[2]) - 1, Number(match[3]));
        var h = Number(match[4] || 0) - tzHour;
        var m = Number(match[5] || 0) - tzMin;
        var s = Number(match[6] || 0);
        var ms = Math.round(parseFloat('0.' + (match[7] || 0)) * 1000);
        timeSetter.call(date, h, m, s, ms);
        return date;
    }

    var L10nCache = /** @class */ (function () {
        function L10nCache() {
            this.cache = {};
        }
        L10nCache.prototype.read = function (key, request) {
            if (this.cache[key])
                return this.cache[key];
            var response = request.pipe(operators.shareReplay(1));
            this.cache[key] = response;
            return response;
        };
        return L10nCache;
    }());
    L10nCache.decorators = [
        { type: i0.Injectable }
    ];

    /**
     * Implement this class-interface to create a storage for the locale.
     */
    var L10nStorage = /** @class */ (function () {
        function L10nStorage() {
        }
        return L10nStorage;
    }());
    L10nStorage.decorators = [
        { type: i0.Injectable }
    ];
    var L10nDefaultStorage = /** @class */ (function () {
        function L10nDefaultStorage() {
        }
        L10nDefaultStorage.prototype.read = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, Promise.resolve(null)];
                });
            });
        };
        L10nDefaultStorage.prototype.write = function (locale) {
            return __awaiter(this, void 0, void 0, function () { return __generator(this, function (_a) {
                return [2 /*return*/];
            }); });
        };
        return L10nDefaultStorage;
    }());
    L10nDefaultStorage.decorators = [
        { type: i0.Injectable }
    ];

    /**
     * Implement this class-interface to get the user language.
     */
    var L10nUserLanguage = /** @class */ (function () {
        function L10nUserLanguage() {
        }
        return L10nUserLanguage;
    }());
    L10nUserLanguage.decorators = [
        { type: i0.Injectable }
    ];
    var L10nDefaultUserLanguage = /** @class */ (function () {
        function L10nDefaultUserLanguage(config) {
            this.config = config;
        }
        L10nDefaultUserLanguage.prototype.get = function () {
            return __awaiter(this, void 0, void 0, function () {
                var browserLanguage;
                return __generator(this, function (_a) {
                    browserLanguage = getBrowserLanguage(this.config.format);
                    return [2 /*return*/, Promise.resolve(browserLanguage)];
                });
            });
        };
        return L10nDefaultUserLanguage;
    }());
    L10nDefaultUserLanguage.decorators = [
        { type: i0.Injectable }
    ];
    L10nDefaultUserLanguage.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_CONFIG,] }] }
    ]; };

    /**
     * Implement this class-interface to create a loader of translation data.
     */
    var L10nTranslationLoader = /** @class */ (function () {
        function L10nTranslationLoader() {
        }
        return L10nTranslationLoader;
    }());
    L10nTranslationLoader.decorators = [
        { type: i0.Injectable }
    ];
    var L10nDefaultTranslationLoader = /** @class */ (function () {
        function L10nDefaultTranslationLoader() {
        }
        L10nDefaultTranslationLoader.prototype.get = function (language, provider) {
            return provider.asset[language] ?
                rxjs.of(provider.asset[language]) :
                rxjs.throwError(l10nError(L10nDefaultTranslationLoader, 'Asset not found'));
        };
        return L10nDefaultTranslationLoader;
    }());
    L10nDefaultTranslationLoader.decorators = [
        { type: i0.Injectable }
    ];

    /**
     * Implement this class-interface to create a translation fallback.
     */
    var L10nTranslationFallback = /** @class */ (function () {
        function L10nTranslationFallback() {
        }
        return L10nTranslationFallback;
    }());
    L10nTranslationFallback.decorators = [
        { type: i0.Injectable }
    ];
    var L10nDefaultTranslationFallback = /** @class */ (function () {
        function L10nDefaultTranslationFallback(config, cache, translationLoader) {
            this.config = config;
            this.cache = cache;
            this.translationLoader = translationLoader;
        }
        /**
         * Translation data will be merged in the following order:
         * 'language'
         * 'language[-script]'
         * 'language[-script][-region]'
         */
        L10nDefaultTranslationFallback.prototype.get = function (language, provider) {
            var e_1, _a;
            var loaders = [];
            var keywords = language.match(/-?[a-zA-z]+/g) || [];
            var fallbackLanguage = '';
            try {
                for (var keywords_1 = __values(keywords), keywords_1_1 = keywords_1.next(); !keywords_1_1.done; keywords_1_1 = keywords_1.next()) {
                    var keyword = keywords_1_1.value;
                    fallbackLanguage += keyword;
                    if (this.config.cache) {
                        loaders.push(this.cache.read(provider.name + "-" + fallbackLanguage, this.translationLoader.get(fallbackLanguage, provider)));
                    }
                    else {
                        loaders.push(this.translationLoader.get(fallbackLanguage, provider));
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (keywords_1_1 && !keywords_1_1.done && (_a = keywords_1.return)) _a.call(keywords_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return loaders;
        };
        return L10nDefaultTranslationFallback;
    }());
    L10nDefaultTranslationFallback.decorators = [
        { type: i0.Injectable }
    ];
    L10nDefaultTranslationFallback.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_CONFIG,] }] },
        { type: L10nCache },
        { type: L10nTranslationLoader }
    ]; };

    /**
     * Implement this class-interface to create an handler for translated values.
     */
    var L10nTranslationHandler = /** @class */ (function () {
        function L10nTranslationHandler() {
        }
        return L10nTranslationHandler;
    }());
    L10nTranslationHandler.decorators = [
        { type: i0.Injectable }
    ];
    var L10nDefaultTranslationHandler = /** @class */ (function () {
        function L10nDefaultTranslationHandler() {
        }
        L10nDefaultTranslationHandler.prototype.parseValue = function (key, params, value) {
            if (params)
                return handleParams(value, params);
            return value;
        };
        return L10nDefaultTranslationHandler;
    }());
    L10nDefaultTranslationHandler.decorators = [
        { type: i0.Injectable }
    ];

    /**
     * Implement this class-interface to create an handler for missing values.
     */
    var L10nMissingTranslationHandler = /** @class */ (function () {
        function L10nMissingTranslationHandler() {
        }
        return L10nMissingTranslationHandler;
    }());
    L10nMissingTranslationHandler.decorators = [
        { type: i0.Injectable }
    ];
    var L10nDefaultMissingTranslationHandler = /** @class */ (function () {
        function L10nDefaultMissingTranslationHandler() {
        }
        L10nDefaultMissingTranslationHandler.prototype.handle = function (key, value, params) {
            return key;
        };
        return L10nDefaultMissingTranslationHandler;
    }());
    L10nDefaultMissingTranslationHandler.decorators = [
        { type: i0.Injectable }
    ];

    /**
     * Implement this class-interface to change the localized path.
     */
    var L10nLocation = /** @class */ (function () {
        function L10nLocation() {
        }
        return L10nLocation;
    }());
    L10nLocation.decorators = [
        { type: i0.Injectable }
    ];
    var L10nDefaultLocation = /** @class */ (function () {
        function L10nDefaultLocation(config, injector) {
            this.config = config;
            this.injector = injector;
        }
        Object.defineProperty(L10nDefaultLocation.prototype, "location", {
            get: function () {
                return this.injector.get(common.Location);
            },
            enumerable: false,
            configurable: true
        });
        L10nDefaultLocation.prototype.path = function () {
            return this.location.path(true);
        };
        L10nDefaultLocation.prototype.parsePath = function (path) {
            if (!path)
                return null;
            var segment = this.getLocalizedSegment(path);
            if (segment != null) {
                var language = segment.replace(/\//g, '');
                return language;
            }
            return null;
        };
        L10nDefaultLocation.prototype.getLocalizedSegment = function (path) {
            var e_1, _a;
            try {
                for (var _b = __values(this.config.schema), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var element = _c.value;
                    var language = formatLanguage(element.locale.language, this.config.format);
                    var regex = new RegExp("(/" + language + "/)|(/" + language + "$)|(/(" + language + ")(?=\\?))|(/(" + language + ")(?=\\#))");
                    var segments = path.match(regex);
                    if (segments != null) {
                        return segments[0];
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return null;
        };
        L10nDefaultLocation.prototype.toLocalizedPath = function (language, path) {
            var segment = this.getLocalizedSegment(path);
            if (segment != null && segment.includes(language))
                return path;
            return common.Location.stripTrailingSlash('/' + language + path);
        };
        return L10nDefaultLocation;
    }());
    L10nDefaultLocation.decorators = [
        { type: i0.Injectable }
    ];
    L10nDefaultLocation.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_CONFIG,] }] },
        { type: i0.Injector }
    ]; };

    var L10nTranslationService = /** @class */ (function () {
        function L10nTranslationService(config, locale, cache, storage, userLanguage, translationFallback, translationLoader, translationHandler, missingTranslationHandler, location) {
            this.config = config;
            this.locale = locale;
            this.cache = cache;
            this.storage = storage;
            this.userLanguage = userLanguage;
            this.translationFallback = translationFallback;
            this.translationLoader = translationLoader;
            this.translationHandler = translationHandler;
            this.missingTranslationHandler = missingTranslationHandler;
            this.location = location;
            /**
             * The translation data: {language: {key: value}}
             */
            this.data = {};
            this.translation = new rxjs.BehaviorSubject(this.locale);
            this.error = new rxjs.BehaviorSubject(null);
        }
        /**
         * Gets the current locale.
         */
        L10nTranslationService.prototype.getLocale = function () {
            return this.locale;
        };
        /**
         * Changes the current locale and load the translation data.
         * @param locale The new locale
         */
        L10nTranslationService.prototype.setLocale = function (locale) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.loadTranslation(this.config.providers, locale)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Fired every time the translation data has been loaded. Returns the locale.
         */
        L10nTranslationService.prototype.onChange = function () {
            return this.translation.asObservable();
        };
        /**
         * Fired when the translation data could not been loaded. Returns the error.
         */
        L10nTranslationService.prototype.onError = function () {
            return this.error.asObservable();
        };
        /**
         * Translates a key or an array of keys.
         * @param keys The key or an array of keys to be translated
         * @param params Optional parameters contained in the key
         * @param language The current language
         * @return The translated value or an object: {key: value}
         */
        L10nTranslationService.prototype.translate = function (keys, params, language) {
            var e_1, _a;
            if (language === void 0) { language = this.locale.language; }
            language = formatLanguage(language, this.config.format);
            if (Array.isArray(keys)) {
                var data = {};
                try {
                    for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                        var key = keys_1_1.value;
                        data[key] = this.translate(key, params, language);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                return data;
            }
            var value = getValue(keys, this.data[language], this.config.keySeparator);
            return value ? this.translationHandler.parseValue(keys, params, value) : this.missingTranslationHandler.handle(keys, value, params);
        };
        /**
         * Checks if a translation exists.
         * @param key The key to be tested
         * @param language The current language
         */
        L10nTranslationService.prototype.has = function (key, language) {
            if (language === void 0) { language = this.locale.language; }
            language = formatLanguage(language, this.config.format);
            return getValue(key, this.data[language], this.config.keySeparator) !== null;
        };
        /**
         * Gets the language direction.
         */
        L10nTranslationService.prototype.getLanguageDirection = function (language) {
            if (language === void 0) { language = this.locale.language; }
            var schema = getSchema(this.config.schema, language, this.config.format);
            if (schema)
                return schema.dir;
        };
        /**
         * Gets available languages.
         */
        L10nTranslationService.prototype.getAvailableLanguages = function () {
            var _this = this;
            var languages = this.config.schema.map(function (item) { return formatLanguage(item.locale.language, _this.config.format); });
            return languages;
        };
        /**
         * Should only be called when the service instance is created.
         */
        L10nTranslationService.prototype.init = function () {
            return __awaiter(this, void 0, void 0, function () {
                var locale, path, pathLanguage, schema, browserLanguage, schema;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            locale = null;
                            if (!this.location) return [3 /*break*/, 2];
                            path = this.location.path();
                            return [4 /*yield*/, this.location.parsePath(path)];
                        case 1:
                            pathLanguage = _a.sent();
                            if (pathLanguage) {
                                schema = getSchema(this.config.schema, pathLanguage, this.config.format);
                                if (schema) {
                                    locale = schema.locale;
                                }
                            }
                            _a.label = 2;
                        case 2:
                            if (!(locale == null)) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.storage.read()];
                        case 3:
                            locale = _a.sent();
                            _a.label = 4;
                        case 4:
                            if (!(locale == null)) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.userLanguage.get()];
                        case 5:
                            browserLanguage = _a.sent();
                            if (browserLanguage) {
                                schema = getSchema(this.config.schema, browserLanguage, this.config.format);
                                if (schema) {
                                    locale = schema.locale;
                                }
                            }
                            _a.label = 6;
                        case 6:
                            // Gets the default locale.
                            if (locale == null) {
                                locale = this.config.defaultLocale;
                            }
                            // Loads translation data.
                            return [4 /*yield*/, this.loadTranslation(this.config.providers, locale)];
                        case 7:
                            // Loads translation data.
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Can be called at every translation change.
         * @param providers An array of L10nProvider
         * @param locale The current locale
         */
        L10nTranslationService.prototype.loadTranslation = function (providers, locale) {
            if (providers === void 0) { providers = this.config.providers; }
            if (locale === void 0) { locale = this.locale; }
            return __awaiter(this, void 0, void 0, function () {
                var language;
                var _this = this;
                return __generator(this, function (_a) {
                    // Updates providers
                    providers.forEach(function (provider) {
                        if (!_this.config.providers.find(function (p) { return p.name === provider.name; })) {
                            _this.config.providers.push(provider);
                        }
                    });
                    language = formatLanguage(locale.language, this.config.format);
                    return [2 /*return*/, new Promise(function (resolve) {
                            rxjs.concat.apply(void 0, __spread(_this.getTranslation(providers, language))).subscribe({
                                next: function (data) { return _this.addData(data, language); },
                                error: function (error) {
                                    _this.handleError(error);
                                    resolve();
                                },
                                complete: function () {
                                    _this.releaseTranslation(locale);
                                    resolve();
                                }
                            });
                        })];
                });
            });
        };
        /**
         * Can be called to add translation data.
         * @param data The translation data {key: value}
         * @param language The language to add data
         */
        L10nTranslationService.prototype.addData = function (data, language) {
            this.data[language] = this.data[language] !== undefined
                ? mergeDeep(this.data[language], data)
                : data;
        };
        L10nTranslationService.prototype.getTranslation = function (providers, language) {
            var e_2, _a;
            var lazyLoaders = [];
            var loaders = [];
            try {
                for (var providers_1 = __values(providers), providers_1_1 = providers_1.next(); !providers_1_1.done; providers_1_1 = providers_1.next()) {
                    var provider = providers_1_1.value;
                    if (this.config.fallback) {
                        loaders = loaders.concat(this.translationFallback.get(language, provider));
                    }
                    else {
                        if (this.config.cache) {
                            lazyLoaders.push(this.cache.read(provider.name + "-" + language, this.translationLoader.get(language, provider)));
                        }
                        else {
                            lazyLoaders.push(this.translationLoader.get(language, provider));
                        }
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (providers_1_1 && !providers_1_1.done && (_a = providers_1.return)) _a.call(providers_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            loaders.push(rxjs.merge.apply(void 0, __spread(lazyLoaders)));
            return loaders;
        };
        L10nTranslationService.prototype.handleError = function (error) {
            this.error.next(error);
        };
        L10nTranslationService.prototype.releaseTranslation = function (locale) {
            Object.assign(this.locale, locale);
            this.translation.next(this.locale);
            this.storage.write(this.locale);
        };
        return L10nTranslationService;
    }());
    L10nTranslationService.decorators = [
        { type: i0.Injectable }
    ];
    L10nTranslationService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_CONFIG,] }] },
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_LOCALE,] }] },
        { type: L10nCache },
        { type: L10nStorage },
        { type: L10nUserLanguage },
        { type: L10nTranslationFallback },
        { type: L10nTranslationLoader },
        { type: L10nTranslationHandler },
        { type: L10nMissingTranslationHandler },
        { type: L10nLocation, decorators: [{ type: i0.Optional }] }
    ]; };

    var L10nAsyncPipe = /** @class */ (function () {
        function L10nAsyncPipe(translation, cdr) {
            var _this = this;
            this.translation = translation;
            this.cdr = cdr;
            this.onChanges = this.translation.onChange().subscribe({
                next: function () { return _this.cdr.markForCheck(); }
            });
        }
        L10nAsyncPipe.prototype.ngOnDestroy = function () {
            if (this.onChanges)
                this.onChanges.unsubscribe();
        };
        return L10nAsyncPipe;
    }());
    L10nAsyncPipe.decorators = [
        { type: i0.Injectable }
    ];
    L10nAsyncPipe.ctorParameters = function () { return [
        { type: L10nTranslationService },
        { type: i0.ChangeDetectorRef }
    ]; };

    /**
     * Breadth First Search (BFS) algorithm for traversing & searching tree data structure of DOM
     * explores the neighbor nodes first, before moving to the next level neighbors.
     * Time complexity: between O(1) and O(|V|^2).
     */
    function getTargetNode(rootNode) {
        return walk(rootNode);
    }
    var MAX_DEPTH = 10;
    function walk(rootNode) {
        var e_1, _a;
        var queue = [];
        var iNode;
        var depth = 0;
        var nodeToDepthIncrease = 1;
        queue.push(rootNode);
        while (queue.length > 0 && depth <= MAX_DEPTH) {
            iNode = queue.splice(0, 1)[0];
            if (isTargetNode(iNode))
                return iNode;
            if (depth < MAX_DEPTH && iNode.childNodes) {
                try {
                    for (var _b = (e_1 = void 0, __values(Array.from(iNode.childNodes))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var child = _c.value;
                        if (isValidNode(child)) {
                            queue.push(child);
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            if (--nodeToDepthIncrease === 0) {
                depth++;
                nodeToDepthIncrease = queue.length;
            }
        }
        return rootNode;
    }
    function isTargetNode(node) {
        return typeof node !== 'undefined' && node.nodeType === 3 && node.nodeValue != null && node.nodeValue.trim() !== '';
    }
    /**
     * A valid node is not marked for translation.
     */
    function isValidNode(node) {
        var e_2, _a;
        if (typeof node !== 'undefined' && node.nodeType === 1 && node.attributes) {
            try {
                for (var _b = __values(Array.from(node.attributes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var attr = _c.value;
                    if (attr && /^l10n|translate/.test(attr.name))
                        return false;
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        return true;
    }

    var L10nDirective = /** @class */ (function () {
        function L10nDirective(el, renderer, translation) {
            this.el = el;
            this.renderer = renderer;
            this.translation = translation;
            this.destroy = new rxjs.Subject();
        }
        Object.defineProperty(L10nDirective.prototype, "innerHTML", {
            set: function (content) {
                // Handle TrustedHTML
                this.content = content.toString();
            },
            enumerable: false,
            configurable: true
        });
        L10nDirective.prototype.ngAfterViewInit = function () {
            if (this.el && this.el.nativeElement) {
                this.element = this.el.nativeElement;
                this.renderNode = getTargetNode(this.element);
                this.text = this.getText();
                this.attributes = this.getAttributes();
                this.addTextListener();
                if (this.language) {
                    this.replaceText();
                    this.replaceAttributes();
                }
                else {
                    this.addTranslationListener();
                }
            }
        };
        L10nDirective.prototype.ngOnChanges = function () {
            if (this.text) {
                if (this.nodeValue == null || this.nodeValue === '') {
                    if (this.value) {
                        this.text = this.value;
                    }
                    else if (this.content) {
                        this.text = this.content;
                    }
                }
                this.replaceText();
            }
            if (this.attributes && this.attributes.length > 0) {
                this.replaceAttributes();
            }
        };
        L10nDirective.prototype.ngOnDestroy = function () {
            this.destroy.next(true);
            this.removeTextListener();
        };
        L10nDirective.prototype.getText = function () {
            var text = '';
            if (this.element.childNodes.length > 0) {
                text = this.getNodeValue();
            }
            else if (this.value) {
                text = this.value;
            }
            else if (this.content) {
                text = this.content;
            }
            return text;
        };
        L10nDirective.prototype.getNodeValue = function () {
            this.nodeValue = this.renderNode != null && this.renderNode.nodeValue != null ? this.renderNode.nodeValue : '';
            return this.nodeValue ? this.nodeValue.trim() : '';
        };
        L10nDirective.prototype.getAttributes = function () {
            var e_1, _a;
            var attributes = [];
            if (this.element.attributes) {
                var _loop_1 = function (attr) {
                    if (attr && attr.name) {
                        var _a = __read(attr.name.match(/^l10n-(.+)$/) || [], 2), _b = _a[1], name_1 = _b === void 0 ? '' : _b;
                        if (name_1) {
                            var targetAttr = Array.from(this_1.element.attributes).find(function (a) { return a.name === name_1; });
                            if (targetAttr)
                                attributes.push({ name: targetAttr.name, value: targetAttr.value });
                        }
                    }
                };
                var this_1 = this;
                try {
                    for (var _b = __values(Array.from(this.element.attributes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var attr = _c.value;
                        _loop_1(attr);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            return attributes;
        };
        L10nDirective.prototype.addTextListener = function () {
            var _this = this;
            if (typeof MutationObserver !== 'undefined') {
                this.textObserver = new MutationObserver(function () {
                    _this.renderNode = getTargetNode(_this.element);
                    _this.text = _this.getText();
                    _this.replaceText();
                });
                this.textObserver.observe(this.renderNode, { subtree: true, characterData: true });
            }
        };
        L10nDirective.prototype.removeTextListener = function () {
            if (typeof this.textObserver !== 'undefined') {
                this.textObserver.disconnect();
            }
        };
        L10nDirective.prototype.addTranslationListener = function () {
            var _this = this;
            this.translation.onChange().pipe(operators.takeUntil(this.destroy)).subscribe({
                next: function () {
                    _this.replaceText();
                    _this.replaceAttributes();
                }
            });
        };
        L10nDirective.prototype.replaceText = function () {
            if (this.text) {
                this.setText(this.getValue(this.text));
            }
        };
        L10nDirective.prototype.replaceAttributes = function () {
            if (this.attributes.length > 0) {
                this.setAttributes(this.getAttributesValues());
            }
        };
        L10nDirective.prototype.setText = function (value) {
            if (value) {
                if (this.nodeValue && this.text) {
                    this.removeTextListener();
                    this.renderer.setValue(this.renderNode, this.nodeValue.replace(this.text, value));
                    this.addTextListener();
                }
                else if (this.value) {
                    this.renderer.setAttribute(this.element, 'value', value);
                }
                else if (this.content) {
                    this.renderer.setProperty(this.element, 'innerHTML', value);
                }
            }
        };
        L10nDirective.prototype.setAttributes = function (data) {
            var e_2, _a;
            try {
                for (var _b = __values(this.attributes), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var attr = _c.value;
                    this.renderer.setAttribute(this.element, attr.name, data[attr.value]);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
        };
        L10nDirective.prototype.getAttributesValues = function () {
            var e_3, _a;
            var values = this.attributes.map(function (attr) { return attr.value; });
            var data = {};
            try {
                for (var values_1 = __values(values), values_1_1 = values_1.next(); !values_1_1.done; values_1_1 = values_1.next()) {
                    var value = values_1_1.value;
                    data[value] = this.getValue(value);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (values_1_1 && !values_1_1.done && (_a = values_1.return)) _a.call(values_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return data;
        };
        return L10nDirective;
    }());
    L10nDirective.decorators = [
        { type: i0.Directive }
    ];
    L10nDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: L10nTranslationService }
    ]; };
    L10nDirective.propDecorators = {
        value: [{ type: i0.Input }],
        innerHTML: [{ type: i0.Input }],
        language: [{ type: i0.Input }]
    };

    var L10nResolver = /** @class */ (function () {
        function L10nResolver(translation) {
            this.translation = translation;
        }
        L10nResolver.prototype.resolve = function (route, state) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.translation.init()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.translation.loadTranslation(route.data.l10nProviders)];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return L10nResolver;
    }());
    L10nResolver.ɵprov = i0.ɵɵdefineInjectable({ factory: function L10nResolver_Factory() { return new L10nResolver(i0.ɵɵinject(L10nTranslationService)); }, token: L10nResolver, providedIn: "root" });
    L10nResolver.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    L10nResolver.ctorParameters = function () { return [
        { type: L10nTranslationService }
    ]; };

    var L10nRoutingService = /** @class */ (function () {
        function L10nRoutingService(platformId, config, locale, translation, l10nLocation, injector) {
            this.platformId = platformId;
            this.config = config;
            this.locale = locale;
            this.translation = translation;
            this.l10nLocation = l10nLocation;
            this.injector = injector;
        }
        Object.defineProperty(L10nRoutingService.prototype, "router", {
            get: function () {
                return this.injector.get(router.Router);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(L10nRoutingService.prototype, "location", {
            get: function () {
                return this.injector.get(common.Location);
            },
            enumerable: false,
            configurable: true
        });
        L10nRoutingService.prototype.init = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    // Parses the url to find the language when a navigation starts.
                    this.router.events.pipe(operators.filter(function (event) { return event instanceof router.NavigationStart; })).subscribe({
                        next: function (event) {
                            // Skips location change on pop state event and on first navigation.
                            _this.redirectToPath(event.url, event.navigationTrigger === 'popstate' || event.id === 1);
                        }
                    });
                    // Replaces url when a navigation ends.
                    this.router.events.pipe(operators.filter(function (event) { return event instanceof router.NavigationEnd; })).subscribe({
                        next: function (event) {
                            var url = (event.url && event.url !== '/' && event.url === event.urlAfterRedirects) ?
                                event.url :
                                event.urlAfterRedirects;
                            _this.replacePath(_this.locale, url);
                        }
                    });
                    if (common.isPlatformBrowser(this.platformId)) {
                        // Replaces url when locale changes.
                        this.translation.onChange().subscribe({
                            next: function (locale) { return _this.replacePath(locale); }
                        });
                    }
                    return [2 /*return*/];
                });
            });
        };
        /**
         * Removes the language from the path and navigates.
         * @param path Localized path
         * @param skipLocationChange When true, navigates without pushing a new state into history
         */
        L10nRoutingService.prototype.redirectToPath = function (path, skipLocationChange) {
            var segment = this.l10nLocation.getLocalizedSegment(path);
            if (segment != null) {
                var url = path.replace(segment, '/');
                // navigateByUrl keeps the query params.
                this.router.navigateByUrl(url, { skipLocationChange: skipLocationChange });
            }
        };
        /**
         * Replaces the path with the language without pushing a new state into history.
         * @param locale The current locale
         * @param path The path to be replaced
         */
        L10nRoutingService.prototype.replacePath = function (locale, path) {
            if (locale.language === '')
                return;
            var language = formatLanguage(locale.language, this.config.format);
            if (path) {
                if (!this.isDefaultRouting()) {
                    this.location.replaceState(this.l10nLocation.toLocalizedPath(language, path));
                }
            }
            else {
                path = this.l10nLocation.path();
                var segment = this.l10nLocation.getLocalizedSegment(path);
                if (segment != null) {
                    path = path.replace(segment, '/');
                    if (this.isDefaultRouting()) {
                        this.location.replaceState(path);
                    }
                }
                if (!this.isDefaultRouting()) {
                    this.location.replaceState(this.l10nLocation.toLocalizedPath(language, path));
                }
            }
        };
        L10nRoutingService.prototype.isDefaultRouting = function () {
            if (!this.config.defaultRouting)
                return false;
            return formatLanguage(this.locale.language, this.config.format) ===
                formatLanguage(this.config.defaultLocale.language, this.config.format);
        };
        return L10nRoutingService;
    }());
    L10nRoutingService.decorators = [
        { type: i0.Injectable }
    ];
    L10nRoutingService.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] },
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_CONFIG,] }] },
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_LOCALE,] }] },
        { type: L10nTranslationService },
        { type: L10nLocation },
        { type: i0.Injector }
    ]; };

    /**
     * Implement this class-interface to init L10n.
     */
    var L10nLoader = /** @class */ (function () {
        function L10nLoader() {
        }
        return L10nLoader;
    }());
    L10nLoader.decorators = [
        { type: i0.Injectable }
    ];
    var L10nDefaultLoader = /** @class */ (function () {
        function L10nDefaultLoader(translation) {
            this.translation = translation;
        }
        L10nDefaultLoader.prototype.init = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.translation.init()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return L10nDefaultLoader;
    }());
    L10nDefaultLoader.decorators = [
        { type: i0.Injectable }
    ];
    L10nDefaultLoader.ctorParameters = function () { return [
        { type: L10nTranslationService }
    ]; };
    var L10nRoutingLoader = /** @class */ (function () {
        function L10nRoutingLoader(routing, translation) {
            this.routing = routing;
            this.translation = translation;
        }
        L10nRoutingLoader.prototype.init = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.routing.init()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.translation.init()];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return L10nRoutingLoader;
    }());
    L10nRoutingLoader.decorators = [
        { type: i0.Injectable }
    ];
    L10nRoutingLoader.ctorParameters = function () { return [
        { type: L10nRoutingService },
        { type: L10nTranslationService }
    ]; };

    var L10nTranslatePipe = /** @class */ (function () {
        function L10nTranslatePipe(translation) {
            this.translation = translation;
        }
        L10nTranslatePipe.prototype.transform = function (key, language, params) {
            if (key == null || key === '')
                return null;
            return this.translation.translate(key, params, language);
        };
        return L10nTranslatePipe;
    }());
    L10nTranslatePipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'translate',
                    pure: true
                },] }
    ];
    L10nTranslatePipe.ctorParameters = function () { return [
        { type: L10nTranslationService }
    ]; };
    var L10nTranslateAsyncPipe = /** @class */ (function (_super) {
        __extends(L10nTranslateAsyncPipe, _super);
        function L10nTranslateAsyncPipe(translation, cdr) {
            var _this = _super.call(this, translation, cdr) || this;
            _this.translation = translation;
            _this.cdr = cdr;
            return _this;
        }
        L10nTranslateAsyncPipe.prototype.transform = function (key, params, language) {
            if (key == null || key === '')
                return null;
            return this.translation.translate(key, params, language);
        };
        return L10nTranslateAsyncPipe;
    }(L10nAsyncPipe));
    L10nTranslateAsyncPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'translateAsync',
                    pure: false
                },] }
    ];
    L10nTranslateAsyncPipe.ctorParameters = function () { return [
        { type: L10nTranslationService },
        { type: i0.ChangeDetectorRef }
    ]; };

    var L10nTranslateDirective = /** @class */ (function (_super) {
        __extends(L10nTranslateDirective, _super);
        function L10nTranslateDirective(el, renderer, translation) {
            var _this = _super.call(this, el, renderer, translation) || this;
            _this.el = el;
            _this.renderer = renderer;
            _this.translation = translation;
            return _this;
        }
        Object.defineProperty(L10nTranslateDirective.prototype, "l10nTranslate", {
            set: function (params) {
                this.params = params;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(L10nTranslateDirective.prototype, "translate", {
            set: function (params) {
                this.params = params;
            },
            enumerable: false,
            configurable: true
        });
        L10nTranslateDirective.prototype.getValue = function (text) {
            return this.translation.translate(text, this.params, this.language);
        };
        return L10nTranslateDirective;
    }(L10nDirective));
    L10nTranslateDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[l10nTranslate],[translate]'
                },] }
    ];
    L10nTranslateDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: L10nTranslationService }
    ]; };
    L10nTranslateDirective.propDecorators = {
        l10nTranslate: [{ type: i0.Input }],
        translate: [{ type: i0.Input }],
        params: [{ type: i0.Input }]
    };

    var L10nTranslationModule = /** @class */ (function () {
        function L10nTranslationModule() {
        }
        L10nTranslationModule.forRoot = function (config, token) {
            if (token === void 0) { token = {}; }
            return {
                ngModule: L10nTranslationModule,
                providers: [
                    L10nTranslationService,
                    L10nCache,
                    { provide: L10N_CONFIG, useValue: config },
                    { provide: L10N_LOCALE, useValue: { language: '' } },
                    { provide: L10nStorage, useClass: token.storage || L10nDefaultStorage },
                    { provide: L10nUserLanguage, useClass: token.userLanguage || L10nDefaultUserLanguage },
                    { provide: L10nTranslationFallback, useClass: token.translationFallback || L10nDefaultTranslationFallback },
                    { provide: L10nTranslationLoader, useClass: token.translationLoader || L10nDefaultTranslationLoader },
                    { provide: L10nTranslationHandler, useClass: token.translationHandler || L10nDefaultTranslationHandler },
                    {
                        provide: L10nMissingTranslationHandler,
                        useClass: token.missingTranslationHandler || L10nDefaultMissingTranslationHandler
                    },
                    { provide: L10nLoader, useClass: L10nDefaultLoader }
                ]
            };
        };
        return L10nTranslationModule;
    }());
    L10nTranslationModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        L10nTranslatePipe,
                        L10nTranslateAsyncPipe,
                        L10nTranslateDirective
                    ],
                    exports: [
                        L10nTranslatePipe,
                        L10nTranslateAsyncPipe,
                        L10nTranslateDirective
                    ]
                },] }
    ];

    var L10nIntlService = /** @class */ (function () {
        function L10nIntlService(config, locale, translation) {
            this.config = config;
            this.locale = locale;
            this.translation = translation;
        }
        /**
         * Formats a date.
         * @param value A date, a number (milliseconds since UTC epoch) or an ISO 8601 string
         * @param options A L10n or Intl DateTimeFormatOptions object
         * @param language The current language
         * @param timeZone The current time zone
         */
        L10nIntlService.prototype.formatDate = function (value, options, language, timeZone) {
            if (language === void 0) { language = this.locale.dateLanguage || this.locale.language; }
            if (timeZone === void 0) { timeZone = this.locale.timeZone; }
            if (!hasDateTimeFormat() || language == null || language === '')
                return value;
            value = toDate(value);
            var dateTimeFormatOptions = {};
            if (options) {
                if (options) {
                    var dateStyle = options.dateStyle, timeStyle = options.timeStyle, rest = __rest(options, ["dateStyle", "timeStyle"]);
                    if (dateStyle) {
                        dateTimeFormatOptions = Object.assign(Object.assign({}, dateTimeFormatOptions), PARSE_DATE_STYLE[dateStyle]);
                    }
                    if (timeStyle) {
                        dateTimeFormatOptions = Object.assign(Object.assign({}, dateTimeFormatOptions), PARSE_TIME_STYLE[timeStyle]);
                    }
                    dateTimeFormatOptions = Object.assign(Object.assign({}, dateTimeFormatOptions), rest);
                }
            }
            if (hasTimeZone() && timeZone) {
                dateTimeFormatOptions.timeZone = timeZone;
            }
            return new Intl.DateTimeFormat(language, dateTimeFormatOptions).format(value);
        };
        /**
         * Formats a number.
         * @param value A number or a string
         * @param options A L10n or Intl NumberFormatOptions object
         * @param language The current language
         * @param currency The current currency
         */
        L10nIntlService.prototype.formatNumber = function (value, options, language, currency) {
            if (language === void 0) { language = this.locale.numberLanguage || this.locale.language; }
            if (currency === void 0) { currency = this.locale.currency; }
            if (!hasNumberFormat() && options && options.style === 'currency')
                return value + " " + currency;
            if (!hasNumberFormat() || language == null || language === '')
                return value;
            value = toNumber(value);
            var numberFormatOptions = {};
            if (options) {
                var digits = options.digits, rest = __rest(options, ["digits"]);
                if (digits) {
                    numberFormatOptions = Object.assign(Object.assign({}, numberFormatOptions), parseDigits(digits));
                }
                numberFormatOptions = Object.assign(Object.assign({}, numberFormatOptions), rest);
            }
            if (currency)
                numberFormatOptions.currency = currency;
            return new Intl.NumberFormat(language, numberFormatOptions).format(value);
        };
        /**
         * Formats a relative time.
         * @param value A negative (or positive) number
         * @param unit The unit of the value
         * @param options An Intl RelativeTimeFormatOptions object
         * @param language The current language
         */
        L10nIntlService.prototype.formatRelativeTime = function (value, unit, options, language) {
            if (language === void 0) { language = this.locale.dateLanguage || this.locale.language; }
            if (!hasRelativeTimeFormat() || language == null || language === '')
                return value;
            value = toNumber(value);
            return new Intl.RelativeTimeFormat(language, options).format(value, unit);
        };
        L10nIntlService.prototype.getCurrencySymbol = function (locale) {
            if (locale === void 0) { locale = this.locale; }
            if (!hasNumberFormat())
                return locale.currency;
            var decimal = this.formatNumber(0, { digits: '1.0-0' }, locale.numberLanguage || locale.language);
            var currency = this.formatNumber(0, { digits: '1.0-0', style: 'currency', currencyDisplay: 'symbol' }, locale.numberLanguage || locale.language, locale.currency);
            var symbol = currency.replace(decimal, '');
            symbol = symbol.trim();
            return symbol;
        };
        /**
         * Compares two keys by the value of translation.
         * @param key1 First key to compare
         * @param key1 Second key to compare
         * @param options An Intl CollatorOptions object
         * @param language The current language
         * @return A negative value if the value of translation of key1 comes before the value of translation of key2;
         *         a positive value if key1 comes after key2;
         *         0 if they are considered equal or Intl.Collator is not supported
         */
        L10nIntlService.prototype.compare = function (key1, key2, options, language) {
            if (language === void 0) { language = this.locale.language; }
            if (!hasCollator() || language == null || language === '')
                return 0;
            var value1 = this.translation.translate(key1);
            var value2 = this.translation.translate(key2);
            return new Intl.Collator(language, options).compare(value1, value2);
        };
        /**
         * Gets the plural by a number.
         * @param value The number to get the plural
         * @param options An Intl PluralRulesOptions object
         * @param prefix Optional prefix for the key
         * @param language The current language
         */
        L10nIntlService.prototype.plural = function (value, prefix, options, language) {
            if (prefix === void 0) { prefix = ''; }
            if (language === void 0) { language = this.locale.language; }
            if (!hasPluralRules() || language == null || language === '')
                return value.toString();
            value = toNumber(value);
            var rule = new Intl.PluralRules(language, options).select(value);
            var key = prefix ? "" + prefix + this.config.keySeparator + rule : rule;
            return this.translation.translate(key);
        };
        /**
         * Returns the representation of a list.
         * @param list An array of keys
         * @param options An Intl ListFormatOptions object
         * @param language The current language
         */
        L10nIntlService.prototype.list = function (list, options, language) {
            var _this = this;
            if (language === void 0) { language = this.locale.language; }
            var values = list.map(function (key) { return _this.translation.translate(key); });
            if (!hasListFormat() || language == null || language === '')
                return values.join(', ');
            return new Intl.ListFormat(language, options).format(values);
        };
        /**
         * Returns translation of language, region, script or currency display names
         * @param code ISO code of language, region, script or currency
         * @param options A DisplayNamesOptions object
         * @param language The current language
         */
        L10nIntlService.prototype.displayNames = function (code, options, language) {
            if (language === void 0) { language = this.locale.language; }
            if (!hasDisplayNames() || language == null || language === '')
                return code;
            return new Intl.DisplayNames(language, options).of(code);
        };
        return L10nIntlService;
    }());
    L10nIntlService.decorators = [
        { type: i0.Injectable }
    ];
    L10nIntlService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_CONFIG,] }] },
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_LOCALE,] }] },
        { type: L10nTranslationService }
    ]; };

    var L10nDatePipe = /** @class */ (function () {
        function L10nDatePipe(intl) {
            this.intl = intl;
        }
        L10nDatePipe.prototype.transform = function (value, language, options, timezone) {
            if (value == null || value === '')
                return null;
            return this.intl.formatDate(value, options, language, timezone);
        };
        return L10nDatePipe;
    }());
    L10nDatePipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nDate',
                    pure: true
                },] }
    ];
    L10nDatePipe.ctorParameters = function () { return [
        { type: L10nIntlService }
    ]; };
    var L10nDateAsyncPipe = /** @class */ (function (_super) {
        __extends(L10nDateAsyncPipe, _super);
        function L10nDateAsyncPipe(translation, cdr, intl) {
            var _this = _super.call(this, translation, cdr) || this;
            _this.translation = translation;
            _this.cdr = cdr;
            _this.intl = intl;
            return _this;
        }
        L10nDateAsyncPipe.prototype.transform = function (value, options, language, timezone) {
            if (value == null || value === '')
                return null;
            return this.intl.formatDate(value, options, language, timezone);
        };
        return L10nDateAsyncPipe;
    }(L10nAsyncPipe));
    L10nDateAsyncPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nDateAsync',
                    pure: false
                },] }
    ];
    L10nDateAsyncPipe.ctorParameters = function () { return [
        { type: L10nTranslationService },
        { type: i0.ChangeDetectorRef },
        { type: L10nIntlService }
    ]; };

    var L10nNumberPipe = /** @class */ (function () {
        function L10nNumberPipe(intl) {
            this.intl = intl;
        }
        L10nNumberPipe.prototype.transform = function (value, language, options, currency) {
            if (value == null || value === '')
                return null;
            return this.intl.formatNumber(value, options, language, currency);
        };
        return L10nNumberPipe;
    }());
    L10nNumberPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nNumber',
                    pure: true
                },] }
    ];
    L10nNumberPipe.ctorParameters = function () { return [
        { type: L10nIntlService }
    ]; };
    var L10nNumberAsyncPipe = /** @class */ (function (_super) {
        __extends(L10nNumberAsyncPipe, _super);
        function L10nNumberAsyncPipe(translation, cdr, intl) {
            var _this = _super.call(this, translation, cdr) || this;
            _this.translation = translation;
            _this.cdr = cdr;
            _this.intl = intl;
            return _this;
        }
        L10nNumberAsyncPipe.prototype.transform = function (value, options, language, currency) {
            if (value == null || value === '')
                return null;
            return this.intl.formatNumber(value, options, language, currency);
        };
        return L10nNumberAsyncPipe;
    }(L10nAsyncPipe));
    L10nNumberAsyncPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nNumberAsync',
                    pure: false
                },] }
    ];
    L10nNumberAsyncPipe.ctorParameters = function () { return [
        { type: L10nTranslationService },
        { type: i0.ChangeDetectorRef },
        { type: L10nIntlService }
    ]; };

    var L10nTimeAgoPipe = /** @class */ (function () {
        function L10nTimeAgoPipe(intl) {
            this.intl = intl;
        }
        L10nTimeAgoPipe.prototype.transform = function (value, language, unit, options) {
            if (value == null || value === '')
                return null;
            return this.intl.formatRelativeTime(value, unit, options, language);
        };
        return L10nTimeAgoPipe;
    }());
    L10nTimeAgoPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nTimeAgo',
                    pure: true
                },] }
    ];
    L10nTimeAgoPipe.ctorParameters = function () { return [
        { type: L10nIntlService }
    ]; };
    var L10nTimeAgoAsyncPipe = /** @class */ (function (_super) {
        __extends(L10nTimeAgoAsyncPipe, _super);
        function L10nTimeAgoAsyncPipe(translation, cdr, intl) {
            var _this = _super.call(this, translation, cdr) || this;
            _this.translation = translation;
            _this.cdr = cdr;
            _this.intl = intl;
            return _this;
        }
        L10nTimeAgoAsyncPipe.prototype.transform = function (value, unit, options, language) {
            if (value == null || value === '')
                return null;
            return this.intl.formatRelativeTime(value, unit, options, language);
        };
        return L10nTimeAgoAsyncPipe;
    }(L10nAsyncPipe));
    L10nTimeAgoAsyncPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nTimeAgoAsync',
                    pure: false
                },] }
    ];
    L10nTimeAgoAsyncPipe.ctorParameters = function () { return [
        { type: L10nTranslationService },
        { type: i0.ChangeDetectorRef },
        { type: L10nIntlService }
    ]; };

    var L10nPluralPipe = /** @class */ (function () {
        function L10nPluralPipe(intl) {
            this.intl = intl;
        }
        L10nPluralPipe.prototype.transform = function (value, language, prefix, options) {
            if (value == null || value === '')
                return null;
            return this.intl.plural(value, prefix, options, language);
        };
        return L10nPluralPipe;
    }());
    L10nPluralPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nPlural',
                    pure: true
                },] }
    ];
    L10nPluralPipe.ctorParameters = function () { return [
        { type: L10nIntlService }
    ]; };
    var L10nPluralAsyncPipe = /** @class */ (function (_super) {
        __extends(L10nPluralAsyncPipe, _super);
        function L10nPluralAsyncPipe(translation, cdr, intl) {
            var _this = _super.call(this, translation, cdr) || this;
            _this.translation = translation;
            _this.cdr = cdr;
            _this.intl = intl;
            return _this;
        }
        L10nPluralAsyncPipe.prototype.transform = function (value, language, prefix, options) {
            if (value == null || value === '')
                return null;
            return this.intl.plural(value, prefix, options, language);
        };
        return L10nPluralAsyncPipe;
    }(L10nAsyncPipe));
    L10nPluralAsyncPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nPluralAsync',
                    pure: false
                },] }
    ];
    L10nPluralAsyncPipe.ctorParameters = function () { return [
        { type: L10nTranslationService },
        { type: i0.ChangeDetectorRef },
        { type: L10nIntlService }
    ]; };

    var L10nDisplayNamesPipe = /** @class */ (function () {
        function L10nDisplayNamesPipe(intl) {
            this.intl = intl;
        }
        L10nDisplayNamesPipe.prototype.transform = function (value, language, options) {
            if (value == null || value === '')
                return null;
            return this.intl.displayNames(value, options, language);
        };
        return L10nDisplayNamesPipe;
    }());
    L10nDisplayNamesPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nDisplayNames',
                    pure: true
                },] }
    ];
    L10nDisplayNamesPipe.ctorParameters = function () { return [
        { type: L10nIntlService }
    ]; };
    var L10nDisplayNamesAsyncPipe = /** @class */ (function (_super) {
        __extends(L10nDisplayNamesAsyncPipe, _super);
        function L10nDisplayNamesAsyncPipe(translation, cdr, intl) {
            var _this = _super.call(this, translation, cdr) || this;
            _this.translation = translation;
            _this.cdr = cdr;
            _this.intl = intl;
            return _this;
        }
        L10nDisplayNamesAsyncPipe.prototype.transform = function (value, options, language) {
            if (value == null || value === '')
                return null;
            return this.intl.displayNames(value, options, language);
        };
        return L10nDisplayNamesAsyncPipe;
    }(L10nAsyncPipe));
    L10nDisplayNamesAsyncPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'l10nDisplayNamesAsync',
                    pure: false
                },] }
    ];
    L10nDisplayNamesAsyncPipe.ctorParameters = function () { return [
        { type: L10nTranslationService },
        { type: i0.ChangeDetectorRef },
        { type: L10nIntlService }
    ]; };

    var L10nDateDirective = /** @class */ (function (_super) {
        __extends(L10nDateDirective, _super);
        function L10nDateDirective(el, renderer, translation, intl) {
            var _this = _super.call(this, el, renderer, translation) || this;
            _this.el = el;
            _this.renderer = renderer;
            _this.translation = translation;
            _this.intl = intl;
            return _this;
        }
        Object.defineProperty(L10nDateDirective.prototype, "l10nDate", {
            set: function (options) {
                this.options = options;
            },
            enumerable: false,
            configurable: true
        });
        L10nDateDirective.prototype.getValue = function (text) {
            return this.intl.formatDate(text, this.options, this.language, this.timezone);
        };
        return L10nDateDirective;
    }(L10nDirective));
    L10nDateDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[l10nDate]'
                },] }
    ];
    L10nDateDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: L10nTranslationService },
        { type: L10nIntlService }
    ]; };
    L10nDateDirective.propDecorators = {
        l10nDate: [{ type: i0.Input }],
        options: [{ type: i0.Input }],
        timezone: [{ type: i0.Input }]
    };

    var L10nNumberDirective = /** @class */ (function (_super) {
        __extends(L10nNumberDirective, _super);
        function L10nNumberDirective(el, renderer, translation, intl) {
            var _this = _super.call(this, el, renderer, translation) || this;
            _this.el = el;
            _this.renderer = renderer;
            _this.translation = translation;
            _this.intl = intl;
            return _this;
        }
        Object.defineProperty(L10nNumberDirective.prototype, "l10nNumber", {
            set: function (options) {
                this.options = options;
            },
            enumerable: false,
            configurable: true
        });
        L10nNumberDirective.prototype.getValue = function (text) {
            return this.intl.formatNumber(text, this.options, this.language, this.currency);
        };
        return L10nNumberDirective;
    }(L10nDirective));
    L10nNumberDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[l10nNumber]'
                },] }
    ];
    L10nNumberDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: L10nTranslationService },
        { type: L10nIntlService }
    ]; };
    L10nNumberDirective.propDecorators = {
        l10nNumber: [{ type: i0.Input }],
        options: [{ type: i0.Input }],
        currency: [{ type: i0.Input }]
    };

    var L10nTimeAgoDirective = /** @class */ (function (_super) {
        __extends(L10nTimeAgoDirective, _super);
        function L10nTimeAgoDirective(el, renderer, translation, intl) {
            var _this = _super.call(this, el, renderer, translation) || this;
            _this.el = el;
            _this.renderer = renderer;
            _this.translation = translation;
            _this.intl = intl;
            return _this;
        }
        Object.defineProperty(L10nTimeAgoDirective.prototype, "l10nTimeAgo", {
            set: function (options) {
                this.options = options;
            },
            enumerable: false,
            configurable: true
        });
        L10nTimeAgoDirective.prototype.getValue = function (text) {
            return this.intl.formatRelativeTime(text, this.unit, this.options, this.language);
        };
        return L10nTimeAgoDirective;
    }(L10nDirective));
    L10nTimeAgoDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[l10nTimeAgo]'
                },] }
    ];
    L10nTimeAgoDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: L10nTranslationService },
        { type: L10nIntlService }
    ]; };
    L10nTimeAgoDirective.propDecorators = {
        l10nTimeAgo: [{ type: i0.Input }],
        unit: [{ type: i0.Input }],
        options: [{ type: i0.Input }]
    };

    var L10nIntlModule = /** @class */ (function () {
        function L10nIntlModule() {
        }
        return L10nIntlModule;
    }());
    L10nIntlModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        L10nDatePipe,
                        L10nNumberPipe,
                        L10nTimeAgoPipe,
                        L10nPluralPipe,
                        L10nDisplayNamesPipe,
                        L10nDateAsyncPipe,
                        L10nNumberAsyncPipe,
                        L10nTimeAgoAsyncPipe,
                        L10nPluralAsyncPipe,
                        L10nDisplayNamesAsyncPipe,
                        L10nDateDirective,
                        L10nNumberDirective,
                        L10nTimeAgoDirective
                    ],
                    exports: [
                        L10nDatePipe,
                        L10nNumberPipe,
                        L10nTimeAgoPipe,
                        L10nPluralPipe,
                        L10nDisplayNamesPipe,
                        L10nDateAsyncPipe,
                        L10nNumberAsyncPipe,
                        L10nTimeAgoAsyncPipe,
                        L10nPluralAsyncPipe,
                        L10nDisplayNamesAsyncPipe,
                        L10nDateDirective,
                        L10nNumberDirective,
                        L10nTimeAgoDirective
                    ],
                    providers: [L10nIntlService]
                },] }
    ];

    /**
     * Implement this class-interface to create a validation service.
     */
    var L10nValidation = /** @class */ (function () {
        function L10nValidation() {
        }
        return L10nValidation;
    }());
    L10nValidation.decorators = [
        { type: i0.Injectable }
    ];
    var L10nDefaultValidation = /** @class */ (function () {
        function L10nDefaultValidation(locale) {
            this.locale = locale;
        }
        L10nDefaultValidation.prototype.parseNumber = function (value, options, language) {
            if (language === void 0) { language = this.locale.numberLanguage || this.locale.language; }
            return null;
        };
        L10nDefaultValidation.prototype.parseDate = function (value, options, language) {
            if (language === void 0) { language = this.locale.dateLanguage || this.locale.language; }
            return null;
        };
        return L10nDefaultValidation;
    }());
    L10nDefaultValidation.decorators = [
        { type: i0.Injectable }
    ];
    L10nDefaultValidation.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [L10N_LOCALE,] }] }
    ]; };

    /**
     * Function that takes a control and returns either null when it’s valid, or an error object if it’s not.
     * @param validation The instance of L10nValidation service
     * @param options A L10n or Intl NumberFormatOptions object
     * @param minValue The minimum value
     * @param maxValue The maximum value
     * @param language The current language
     * @return An error object: 'format', 'minValue' or 'maxValue'; null in case the value is valid
     */
    function l10nValidateNumber(validation, options, minValue, maxValue, language) {
        if (minValue === void 0) { minValue = Number.MIN_VALUE; }
        if (maxValue === void 0) { maxValue = Number.MAX_VALUE; }
        var validator = function (c) {
            if (c.value === '' || c.value == null)
                return null;
            var value = validation.parseNumber(c.value, options, language);
            if (value != null) {
                if (value < minValue) {
                    return { minValue: true };
                }
                else if (value > maxValue) {
                    return { maxValue: true };
                }
                return null; // The number is valid.
            }
            else {
                return { format: true };
            }
        };
        return validator;
    }
    var L10nValidateNumberDirective = /** @class */ (function () {
        function L10nValidateNumberDirective(validation) {
            this.validation = validation;
        }
        Object.defineProperty(L10nValidateNumberDirective.prototype, "l10nValidateNumber", {
            set: function (options) {
                this.options = options;
            },
            enumerable: false,
            configurable: true
        });
        L10nValidateNumberDirective.prototype.ngOnInit = function () {
            this.validator = l10nValidateNumber(this.validation, this.options, this.minValue, this.maxValue, this.language);
        };
        L10nValidateNumberDirective.prototype.ngOnChanges = function () {
            this.validator = l10nValidateNumber(this.validation, this.options, this.minValue, this.maxValue, this.language);
        };
        L10nValidateNumberDirective.prototype.validate = function (c) {
            return this.validator(c);
        };
        return L10nValidateNumberDirective;
    }());
    L10nValidateNumberDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[l10nValidateNumber][ngModel],[l10nValidateNumber][formControl],[l10nValidateNumber][formControlName]',
                    providers: [
                        { provide: forms.NG_VALIDATORS, useExisting: i0.forwardRef(function () { return L10nValidateNumberDirective; }), multi: true }
                    ]
                },] }
    ];
    L10nValidateNumberDirective.ctorParameters = function () { return [
        { type: L10nValidation }
    ]; };
    L10nValidateNumberDirective.propDecorators = {
        l10nValidateNumber: [{ type: i0.Input }],
        options: [{ type: i0.Input }],
        minValue: [{ type: i0.Input }],
        maxValue: [{ type: i0.Input }],
        language: [{ type: i0.Input }]
    };

    /**
     * Function that takes a control and returns either null when it’s valid, or an error object if it’s not.
     * @param validation The instance of L10nValidation service
     * @param options A L10n or Intl DateTimeFormatOptions object
     * @param minDate The minimum date
     * @param maxDate The maximum date
     * @param language The current language
     * @return An error object: 'format', 'minDate' or 'maxDate'; null in case the date is valid
     */
    function l10nValidateDate(validation, options, minDate, maxDate, language) {
        var validator = function (c) {
            if (c.value === '' || c.value == null)
                return null;
            var date = validation.parseDate(c.value, options, language);
            if (date != null) {
                if (minDate && date < minDate) {
                    return { mindate: true };
                }
                else if (maxDate && date > maxDate) {
                    return { maxDate: true };
                }
                return null; // The date is valid.
            }
            else {
                return { format: true };
            }
        };
        return validator;
    }
    var L10nValidateDateDirective = /** @class */ (function () {
        function L10nValidateDateDirective(validation) {
            this.validation = validation;
        }
        Object.defineProperty(L10nValidateDateDirective.prototype, "l10nValidateDate", {
            set: function (options) {
                this.options = options;
            },
            enumerable: false,
            configurable: true
        });
        L10nValidateDateDirective.prototype.ngOnInit = function () {
            this.validator = l10nValidateDate(this.validation, this.options, this.minDate, this.maxDate, this.language);
        };
        L10nValidateDateDirective.prototype.ngOnChanges = function () {
            this.validator = l10nValidateDate(this.validation, this.options, this.minDate, this.maxDate, this.language);
        };
        L10nValidateDateDirective.prototype.validate = function (c) {
            return this.validator(c);
        };
        return L10nValidateDateDirective;
    }());
    L10nValidateDateDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[l10nValidateDate][ngModel],[l10nValidateDate][formControl],[l10nValidateDate][formControlName]',
                    providers: [
                        { provide: forms.NG_VALIDATORS, useExisting: i0.forwardRef(function () { return L10nValidateDateDirective; }), multi: true }
                    ]
                },] }
    ];
    L10nValidateDateDirective.ctorParameters = function () { return [
        { type: L10nValidation }
    ]; };
    L10nValidateDateDirective.propDecorators = {
        l10nValidateDate: [{ type: i0.Input }],
        options: [{ type: i0.Input }],
        minDate: [{ type: i0.Input }],
        maxDate: [{ type: i0.Input }],
        language: [{ type: i0.Input }]
    };

    var L10nValidationModule = /** @class */ (function () {
        function L10nValidationModule() {
        }
        L10nValidationModule.forRoot = function (token) {
            if (token === void 0) { token = {}; }
            return {
                ngModule: L10nValidationModule,
                providers: [
                    { provide: L10nValidation, useClass: token.validation || L10nDefaultValidation }
                ]
            };
        };
        return L10nValidationModule;
    }());
    L10nValidationModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        L10nValidateNumberDirective,
                        L10nValidateDateDirective
                    ],
                    exports: [
                        L10nValidateNumberDirective,
                        L10nValidateDateDirective
                    ]
                },] }
    ];

    var L10nRoutingModule = /** @class */ (function () {
        function L10nRoutingModule() {
        }
        L10nRoutingModule.forRoot = function (token) {
            if (token === void 0) { token = {}; }
            return {
                ngModule: L10nRoutingModule,
                providers: [
                    L10nRoutingService,
                    { provide: L10nLocation, useClass: token.location || L10nDefaultLocation },
                    { provide: L10nLoader, useClass: L10nRoutingLoader }
                ]
            };
        };
        return L10nRoutingModule;
    }());
    L10nRoutingModule.decorators = [
        { type: i0.NgModule, args: [{},] }
    ];

    /*
     * Public API Surface of angular-l10n
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.L10N_CONFIG = L10N_CONFIG;
    exports.L10N_LOCALE = L10N_LOCALE;
    exports.L10nAsyncPipe = L10nAsyncPipe;
    exports.L10nCache = L10nCache;
    exports.L10nDateAsyncPipe = L10nDateAsyncPipe;
    exports.L10nDateDirective = L10nDateDirective;
    exports.L10nDatePipe = L10nDatePipe;
    exports.L10nDirective = L10nDirective;
    exports.L10nDisplayNamesAsyncPipe = L10nDisplayNamesAsyncPipe;
    exports.L10nDisplayNamesPipe = L10nDisplayNamesPipe;
    exports.L10nIntlModule = L10nIntlModule;
    exports.L10nIntlService = L10nIntlService;
    exports.L10nLoader = L10nLoader;
    exports.L10nLocation = L10nLocation;
    exports.L10nMissingTranslationHandler = L10nMissingTranslationHandler;
    exports.L10nNumberAsyncPipe = L10nNumberAsyncPipe;
    exports.L10nNumberDirective = L10nNumberDirective;
    exports.L10nNumberPipe = L10nNumberPipe;
    exports.L10nPluralAsyncPipe = L10nPluralAsyncPipe;
    exports.L10nPluralPipe = L10nPluralPipe;
    exports.L10nResolver = L10nResolver;
    exports.L10nRoutingModule = L10nRoutingModule;
    exports.L10nRoutingService = L10nRoutingService;
    exports.L10nStorage = L10nStorage;
    exports.L10nTimeAgoAsyncPipe = L10nTimeAgoAsyncPipe;
    exports.L10nTimeAgoDirective = L10nTimeAgoDirective;
    exports.L10nTimeAgoPipe = L10nTimeAgoPipe;
    exports.L10nTranslateAsyncPipe = L10nTranslateAsyncPipe;
    exports.L10nTranslateDirective = L10nTranslateDirective;
    exports.L10nTranslatePipe = L10nTranslatePipe;
    exports.L10nTranslationFallback = L10nTranslationFallback;
    exports.L10nTranslationHandler = L10nTranslationHandler;
    exports.L10nTranslationLoader = L10nTranslationLoader;
    exports.L10nTranslationModule = L10nTranslationModule;
    exports.L10nTranslationService = L10nTranslationService;
    exports.L10nUserLanguage = L10nUserLanguage;
    exports.L10nValidateDateDirective = L10nValidateDateDirective;
    exports.L10nValidateNumberDirective = L10nValidateNumberDirective;
    exports.L10nValidation = L10nValidation;
    exports.L10nValidationModule = L10nValidationModule;
    exports.PARSE_DATE_STYLE = PARSE_DATE_STYLE;
    exports.PARSE_TIME_STYLE = PARSE_TIME_STYLE;
    exports.formatLanguage = formatLanguage;
    exports.getBrowserLanguage = getBrowserLanguage;
    exports.getSchema = getSchema;
    exports.getValue = getValue;
    exports.handleParams = handleParams;
    exports.hasCollator = hasCollator;
    exports.hasDateTimeFormat = hasDateTimeFormat;
    exports.hasDisplayNames = hasDisplayNames;
    exports.hasIntl = hasIntl;
    exports.hasListFormat = hasListFormat;
    exports.hasNumberFormat = hasNumberFormat;
    exports.hasPluralRules = hasPluralRules;
    exports.hasRelativeTimeFormat = hasRelativeTimeFormat;
    exports.hasTimeZone = hasTimeZone;
    exports.l10nValidateDate = l10nValidateDate;
    exports.l10nValidateNumber = l10nValidateNumber;
    exports.mergeDeep = mergeDeep;
    exports.parseDigits = parseDigits;
    exports.parseLanguage = parseLanguage;
    exports.toDate = toDate;
    exports.toNumber = toNumber;
    exports.validateLanguage = validateLanguage;
    exports.ɵa = L10nDefaultStorage;
    exports.ɵb = L10nDefaultUserLanguage;
    exports.ɵc = L10nDefaultTranslationFallback;
    exports.ɵd = L10nDefaultTranslationLoader;
    exports.ɵe = L10nDefaultTranslationHandler;
    exports.ɵf = L10nDefaultMissingTranslationHandler;
    exports.ɵg = L10nDefaultLoader;
    exports.ɵh = L10nRoutingLoader;
    exports.ɵi = L10nDefaultValidation;
    exports.ɵj = L10nDefaultLocation;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-l10n.umd.js.map
