import { AfterViewInit, OnChanges, OnDestroy, ElementRef, Renderer2 } from '@angular/core';
import { L10nTranslationService } from '../services/l10n-translation.service';
export declare abstract class L10nDirective implements AfterViewInit, OnChanges, OnDestroy {
    protected el: ElementRef;
    protected renderer: Renderer2;
    protected translation: L10nTranslationService;
    value: string;
    set innerHTML(content: any);
    language: string;
    private content;
    private text;
    private attributes;
    private element;
    private renderNode;
    private nodeValue;
    private textObserver;
    private destroy;
    constructor(el: ElementRef, renderer: Renderer2, translation: L10nTranslationService);
    ngAfterViewInit(): void;
    ngOnChanges(): void;
    ngOnDestroy(): void;
    protected abstract getValue(text: string): string;
    private getText;
    private getNodeValue;
    private getAttributes;
    private addTextListener;
    private removeTextListener;
    private addTranslationListener;
    private replaceText;
    private replaceAttributes;
    private setText;
    private setAttributes;
    private getAttributesValues;
}
