import { L10nFormat, L10nSchema } from './types';
export declare function validateLanguage(language: string): boolean;
export declare function formatLanguage(language: string, format: L10nFormat): string;
export declare function parseLanguage(language: string): {
    language: string;
    script: string;
    region: string;
    extension: string;
};
export declare function getBrowserLanguage(format: L10nFormat): string | null;
export declare function getSchema(schema: L10nSchema[], language: string, format: L10nFormat): L10nSchema | undefined;
export declare function getValue(key: string, data: {
    [key: string]: any;
}, keySeparator: string): string | any | null;
export declare function handleParams(value: string, params: any): string;
export declare function mergeDeep(target: {
    [key: string]: any;
}, source: {
    [key: string]: any;
}): any;
export declare function hasIntl(): boolean;
export declare function hasDateTimeFormat(): boolean;
export declare function hasNumberFormat(): boolean;
export declare function hasTimeZone(): boolean;
export declare function hasRelativeTimeFormat(): boolean;
export declare function hasCollator(): boolean;
export declare function hasPluralRules(): boolean;
export declare function hasListFormat(): boolean;
export declare function hasDisplayNames(): boolean;
export declare function toNumber(value: any): number;
export declare function toDate(value: any): Date;
export declare const PARSE_DATE_STYLE: {
    [format: string]: any;
};
export declare const PARSE_TIME_STYLE: {
    [format: string]: any;
};
export declare function parseDigits(digits: string): {
    minimumIntegerDigits: number | undefined;
    minimumFractionDigits: number | undefined;
    maximumFractionDigits: number | undefined;
};
