import { Injector } from '@angular/core';
import { L10nLocale } from '../models/types';
import { L10nConfig } from '../models/l10n-config';
import { L10nTranslationService } from './l10n-translation.service';
import { L10nLocation } from './l10n-location';
export declare class L10nRoutingService {
    private platformId;
    private config;
    private locale;
    private translation;
    private l10nLocation;
    private injector;
    private get router();
    private get location();
    constructor(platformId: Object, config: L10nConfig, locale: L10nLocale, translation: L10nTranslationService, l10nLocation: L10nLocation, injector: Injector);
    init(): Promise<void>;
    /**
     * Removes the language from the path and navigates.
     * @param path Localized path
     * @param skipLocationChange When true, navigates without pushing a new state into history
     */
    private redirectToPath;
    /**
     * Replaces the path with the language without pushing a new state into history.
     * @param locale The current locale
     * @param path The path to be replaced
     */
    private replacePath;
    private isDefaultRouting;
}
