import { L10nConfig } from '../models/l10n-config';
/**
 * Implement this class-interface to get the user language.
 */
export declare abstract class L10nUserLanguage {
    /**
     * This method must contain the logic to get the user language.
     * @return The user language
     */
    abstract get(): Promise<string | null>;
}
export declare class L10nDefaultUserLanguage implements L10nUserLanguage {
    private config;
    constructor(config: L10nConfig);
    get(): Promise<string | null>;
}
